set trace off
orplot, nois

exit
amount(bin sd sd) meffect
meplot, nois amount(bin sd sd) meffect

exit
meplot, nois amount(bin sd sd) meffect

exit
sysuse ordwarm4, clear
mlogit warm i.yr89 i.male i.white age i.edcat prst
mchange2
meplot, nois am(one sd)
orplot yr89 edcat, nois
exit
orplot yr89 edcat, nois am(one sd)

exit
sysuse nomocc4, replace
mlogit occ white ed exper
mchange2, amount(sd)

meplot, nois amount(bin sd sd) meffect
exit
orplot, nois amount(bin sd sd) meffect

exit
graph export orplot.emf, replace
drop _*
meplot, nois amount(bin sd sd)
graph export dcplot.emf, replace


exit
/*
use nomocc4, replace
replace edcat = 3 if edcat==4
mlogit occ i.white i.edcat exper
estimates save mnlm1
estimates use mnlm1
mlogit
exit
*/
use nomocc4, replace
mlogit occ i.white i.edcat exper
mchange2, amount(all)
orplot, nois amount(range) meffect
char list _orme[]
exit
log close
exit
dcplot, nois amount(sd)
char list _orme[]
***********************************************************************
orplot, nois amount(sd)
char list _orme[]

exit

matlist _mchange, format(%8.3f)

_rm_pwnames, var(edcat)
sreturn list

_rm_pwnames, var(white)
sreturn list

_rm_get_mchange, var(white) st(ch) am(one) nois
_rm_get_mchange, var(white) st(p) am(one) nois
_rm_get_mchange, var(edcat) st(ch) pw(2vs1) nois
_rm_get_mchange, var(edcat) st(ch) pw(3vs2) nois



end


exit

local varnm edcat
pwcompare `varnm'
matrix pwmat = r(table_vs) // pw contrasts
local npw = colsof(pwmat)
local pwcolnms : colnames(pwmat)
forvalues ipw = 1/`npw' {
    * pw names using value labels
    _ms_element_info, element(`ipw') matrix(pwmat) compare
    * text label
    local pwtxtlbl `"`r(level)'"' // T vs F
    * get category #'s for contrasts
    local pwnumlbl : word `ipw' of `pwcolnms'
    local pwnumlbl : subinstr local pwnumlbl ".`varnm'" "", all
    local pwnumlbl : subinstr local pwnumlbl "bn" "", all
    local tmp : subinstr local pwnumlbl "vs" " ", all
    * T and F numbers
    local pwFnum : word 2 of `tmp'
    local pwTnum : word 1 of `tmp'
di "st `pwstval' en `pwenval' name `pwtxtlbl'"
} // ipw loop

exit
//  #1


                local optpred ""
                if (`MDLbrm') local colnum = 1
                else if (`MDLcrm') local colnum = 0
                else local optpred "predict(outcome(`catval'))"
                local ++colnum

                local cmdis "margins `varnm' `if' `in', at(`ATbase')"
                local cmdis "`cmdis' `atmeans' `optpred' `options' pwcompare"
                _rm_cleancmd `cmdis'
                local cmdis "`s(cmd)'"
                `quicmd' display "Command: `cmdis'"
                `quimar' `cmdis'

                matrix pwmat = r(table_vs) // pw contrasts
                local npw = colsof(pwmat)
                local npw`varnm' = `npw'
                local pwcolnms : colnames(pwmat)

                matrix `prmat' = r(table) // outcome probabiliteis
                local npr = colsof(`prmat')
                local prcolnms : colnames(`prmat')
                * remove all but numbers from column names
                local prcolnums : subinstr local prcolnms ".`varnm'" "", all
                local prcolnums : subinstr local prcolnums "bn" "", all

                qui `noisily' matlist `prmat', ///
                    title(pr rtable) format(%10.4f)
                qui `noisily' matlist pwmat, ///
                    title(pw rtable_vs) format(%10.4f)

                forvalues ipw = 1/`npw' {

                    * pw names using value lbls
                    _ms_element_info, element(`ipw') matrix(pwmat) compare
                    local pwnm `"`r(level)'"'
                    local pwnmlen = length(`"`r(level)'"') // for matlist
                    if (`pwnmlen'>=`twid') local twid = `pwnmlen' + 1

                    * get category #'s for contrasts
                    local pwcolnm : word `ipw' of `pwcolnms'
                    local pwcolnm : subinstr local pwcolnm ".`varnm'" "", all
                    local pwcolnm : subinstr local pwcolnm "vs" " ", all
                    local pwcolnm : subinstr local pwcolnm "bn" "", all

                    * locations in prmat for start & end predicitons
                    local pwstval : word 2 of `pwcolnm'
                    local pwstcol : list posof "`pwstval'" in prcolnums
                    local pwenval : word 1 of `pwcolnm'
                    local pwencol : list posof "`pwenval'" in prcolnums
*di "st `pwstval' en `pwenval' name `pwnm'"

                    * matrix for pw comparison #ipw
                    capture confirm matrix `pwmat`ipw''
                    if _rc!=0 { // doesn't exist so create
                        * rowname <varnm>!<pwnm>:C<center>A<amount>S<stat>
                                *local rn : subinstr local pwnm " " "_", all
                                *local rn "`varnm'!`rn':AbinC`LBLcntrabbrev'"
                                *local rn "`varnm'!`rn':Abin"
                        * agecat!#vs#:AxxxSxxx
                        local rn "`varnm'!`pwenval'vs`pwstval':Abin"
                        mat `pwmat`ipw'' = `blankmat'
                        matrix rowna `pwmat`ipw'' = `rn'Sch `rn'Sse `rn'Szv ///
                            `rn'Spv `rn'Sll `rn'Sul `rn'Sst `rn'Sen
                    }

                    mat `pwmat`ipw''[7,`colnum'] = `prmat'[1,`pwstcol']
                    mat `pwmat`ipw''[8,`colnum'] = `prmat'[1,`pwencol']
                    mat `pwmat`ipw''[1,`colnum'] = pwmat[1,`ipw']
                    mat `pwmat`ipw''[2,`colnum'] = pwmat[2,`ipw']
                    mat `pwmat`ipw''[3,`colnum'] = pwmat[3,`ipw']
                    mat `pwmat`ipw''[4,`colnum'] = pwmat[4,`ipw']
                    mat `pwmat`ipw''[5,`colnum'] = pwmat[5,`ipw']
                    mat `pwmat`ipw''[6,`colnum'] = pwmat[6,`ipw']

                } // ipw loop

            } // outcome

            forvalues ipw = 1/`npw' { // results for all contrasts
                matrix `allchanges' = nullmat(`allchanges') \ `pwmat`ipw''
            }

        } // type fac

    } // varnm



exit
sysuse nomocc4, clear
mlogit occ i.white i.edcat exper
mchange
orplot
meplot
exit
mchange2

log close
exit

NOTES:

//  #5

//  #6

//  #7

//  #8

//  #9

