capture log close
log using rerun, replace text

clear all
macro drop all
set trace off

qui sysuse ordwarm4, clear
*qui ologit warm i.yr89 i.male i.white age i.edcat prst
qui ologit warm i.yr89 age i.edcat
mchange2
return list
matrix _mchange_effects = r(changes)
matlist _mchange_effects

log close
exit

mchange2, atmeans
mchange2 age white edcat prst, stats(all) amount(all)

sysuse binlfp4, clear
logit lfp k5 k618 i.agecat i.wc i.hc lwg inc
mchange2, stats(all) amount(all)

log close
exit
mchange2
mchange2 agecat inc wc, noi stats(all)
mchange2 agecat inc wc, noi stats(all) amount(marg)

gen agecat2 = agecat + 1
lab def agecat2 2 2_3039 3 3_4049 4 4_5099
logit lfp k5 k618 i.agecat2 i.wc i.hc lwg inc
mchange2 agecat2 ,  noi amount(all) dec(5)

log close
exit

logit lfp k5 k618 i.agecat3 i.wc i.hc lwg inc
mchange2 agecat3 inc wc, noi stats(all)

logit lfp k5 k618 i.agecat2 i.wc i.hc lwg inc
mchange2 agecat2 inc wc, noi stats(all)



log close
exit



* test atspec
local atspec "wc=0 inc=10"
margins, at(wc=1 `atspec' wc=0)
local atspec "wc=1 inc=10"
margins, at(wc=1 `atspec' wc=0)

local atspec "wc=0 inc=10"
margins, at(inc=5 `atspec' inc=10)
local atspec "wc=0 inc=4"
margins, at(inc=5 `atspec' inc=10)

mchange2 wc ,  noi amount(all) dec(5) at(wc=0)
mchange2 wc ,  noi amount(all) dec(5) at(1.wc=1)

exit
mchange2 agecat ,  noi amount(all) dec(5) at(wc=0)

mchange2 agecat ,  noi amount(all) dec(5) at(wc=1)
exit
gen agecat2 = agecat + 1
lab def agecat2 2 2_3039 3 3_4049 4 4_5099
logit lfp k5 k618 i.agecat2 i.wc i.hc lwg inc
mchange2 agecat2 ,  noi amount(all) dec(5)

spex ologitf
mchange2 male edcat, noi amount(all) dec(5)
mchange age, amount(all) statistics(all) dec(5)

log close
sysuse auto

label define stuff 1 "one" 2 "two" 3 "three" 4 "four" 5 "last"
label value rep78 stuff

gsem (for <- mpg turn i.rep, logit) (mpg <- turn trunk)

mata
x = st_matrix("e(b)")', exp(st_matrix("e(b)")') st_matrix("x", x) end matrix colna x = "Coef" "exp(b)"
matrix rowna x = `:colfullname e(b)'

matlist x

_matrix_table x
_matrix_table x, format(%9.2f)
_matrix_table x, format(%9.2f %7.3f)
_matrix_table x, format(%9.2f %7.3f) nofvlabel ***ENDgen agecat2 = agecat + 1
gen agecat3 = agecat2
replace agecat3 = 5 if agecat3==4
logit lfp k5 k618 i.agecat3 i.wc i.hc lwg inc

mchange2 agecat3 inc wc, stats(all) detail amount(sd)
/*
estimates save ologitf
estimates use ologitf
mchange2 age white edcat // crash
*/
